import dbus
import dbus.service
import subprocess
import time
import dbus.mainloop.glib
from gi.repository import GLib

class KodiService(dbus.service.Object):
    def __init__(self):
        try:
            # Connect to the session bus
            bus_name = dbus.service.BusName('org.freedesktop.vicharakKodi', bus=dbus.SessionBus())
            dbus.service.Object.__init__(self, bus_name, '/org/freedesktop/vicharakKodi')
        except Exception as e:
            print(f"Failed to connect to D-Bus: {e}")

    @dbus.service.method('org.freedesktop.vicharakKodi.Interface')
    def PowerOff_Pipewire(self):
        try:
            result = subprocess.run(['systemctl', '--user', 'stop', 'pipewire.socket', 'pipewire.service'], capture_output=True, text=True)
            print(f"STDOUT: {result.stdout}\n")
            print(f"STDERR: {result.stderr}\n")

            if result.returncode == 0:
                print("Successfully stopped pipewire")
            else:
                print(f"Failed to stop pipewire : {result.stderr}")

        except Exception as e:
            print(f"Error managing vicharak-kodi: {e}")

        return "PowerOff Pipewire Service"

    @dbus.service.method('org.freedesktop.vicharakKodi.Interface')
    def PowerOn_Pipewire(self):
        try:
            result = subprocess.run(['systemctl', '--user', 'start', 'pipewire.socket', 'pipewire.service'], capture_output=True, text=True)
            print(f"STDOUT: {result.stdout}\n")
            print(f"STDERR: {result.stderr}\n")

            if result.returncode == 0:
                print("Successfully restarted pipewire service")
            else:
                print(f"Failed to restart pipewire service: {result.stderr}")

        except Exception as e:
            print(f"Error managing vicharak-kodi service: {e}")

        return "PowerOn piewire service"

if __name__ == "__main__":
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
    KodiService()
    GLib.MainLoop().run()
